% 1. Define variables, parameters, etc
  
  var c l R lambda w 
      pi ksibar n v d 
      q k qc B Rk 
      portf x Rp rrp A 
      z Rb Rl i dp 
      pistar x1  x2 mc y 
      wk g tau sigg sigtau 
      sigma ;
      
varexo emt egt etaut eat esigmat ugt utaut ;

parameters habit sigmac beta  epsilonD Phi mu delta rho 
                    wkbar gamma We alpha epsilon theta Phik 
                    phiR phipi phiy 
                    rhog gamgy gamgb 
                    rhotau gamtauy gamtaub 
                    rhoa rhosigma rhosigg rhosigtau
                    etag etatau sigms ;
parameters wks Rs pis pistars ys Bs gs taus siggs sigtaus sigma_ss ;  
                               
% 2. Set Parameters
habit = 0.75 ;  % From ACEL JFV(2015)
sigmac = 0.5 ;   % CRRA JFV(2015)
% beta = 0.99 ;  % Anna(2020)
beta = 1/1.0215 ;
% omegac = 0.99 ;  % ԴԴʽ2019
% phic = 0.5 ;  % ԴԴʽ2019
epsilonD = 4.2869;  % дҲ
Phi = 1 ;  % ԴԴʽ2019
mu = 0.2148945 ;  % Anna(2020)
delta = 0.02 ;  % Anna(2020)/0.01 JFV(2015)/0.025 Plessis et al(2014)
rho = 0.974 ;  % Anna(2020)
wkbar = 1.27 ;  % Anna(2020)
gamma = 0.9624 ;  % Anna(2020)
We = 0.013 ;  % Լ⣬дҲ
alpha = 0.36 ;  % Anna(2020)/ͬJFV(2015)
epsilon = 11 ;  % Anna(2020)/21 JFV(2015)
theta = 0.75 ;  % Լ⣬(۸ճ)дҲ
Phik = 2 ;  % Լ⣬дҲ
phiR =  0.7 ;  % JFV(2015)/0.95 Anna(2020)/0.8 IMF_WP(2017)
phipi = 1.35 ;  % JFV(2015)/1.476 Kevin Kotze(2017)/1.4 Anna(2020)
phiy = 0.25 ;  % JFV(2015)/0.3 IMF_WP(2017)/0.476 Kevin Kotze(2017)
rhog = 0.99 ;  % JFV(2015)/0.957 Kevin Kotze(2017)/0.98  Anna(2020)/Լɼйݽй
gamgy = -0.004 ;  % JFV(2015)/-0.004 Kevin Kotze(2017)/Լɼйݽй
gamgb = -0.008 ;  % JFV(2015)/-0.003 Kevin Kotze(2017)/Լɼйݽй
rhotau = 0.987 ;  %˰ʣｫJFV(2015)ƽԼɼйݽй/0.82  Kevin Kotze(2017)
gamtauy = 0.028 ;  %˰ʣｫJFV(2015)ƽԼɼйݽй/0.0093  Kevin Kotze(2017)
gamtaub = 0.002 ;  %˰ʣｫJFV(2015)ƽԼɼйݽй/-0.001  Kevin Kotze(2017)
rhoa = 0.98 ;  % IMF_WP(2017)
rhosigma = 0.86 ;   % IMF_WP(2017)
rhosigg = 0.92 ;  % JFV(2015)/0.938 Kevin Kotze(2017)/Լɼйݽй
rhosigtau = 0.62 ;  % ˰(0.46 - 0.73)JFV(2015)/0.661 - 0.994  Kevin Kotze(2017)/Լɼйݽй
etag = 0.18 ;    % JFV(2015)// std of inno to vola 
etatau = 0.40 ;   % JFV(2015) οʱ // std of inno to vola 
sigms = exp(-5.5) ;   % JFV(2015) steady-state vola

wks = 0.7079745 ;
Rs = 1.0215 ;
pis = 1;
pistars = 1;
ys = 0.8224 ;
Bs = 4.5423 ;
gs = 0.1596 ;
taus = 0.2207 ;
siggs = -6.20 ;
sigtaus = -4.90 ;
sigma_ss = 0.255234 ;



%  4. Define Model
model ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# Z          = (log(ksibar) + sigma(-1)^2 / 2) / sigma(-1) ;
# Zplus      = (log(ksibar(+1)) + sigma^2 / 2) / sigma ;
# F          = normcdf(Z) ;
# G          = normcdf(Z - sigma(-1)) ;
# Fp1        = normcdf(Zplus) ;
# Gp1        = normcdf(Zplus - sigma) ;
# GAMMA      = ksibar*(1-F)+G ;
# GAMMAp1    = ksibar(+1)*(1-Fp1)+Gp1 ;
# dFp1       = normpdf(Zplus) / ksibar(+1) / sigma ;

# Phi_x = Phik/2 * ( i / (i(-1)) - 1 ) ^ 2 ;
# dPhi_x = Phik * ( i /  i(-1) - 1 ) ; 
# dPhip_x = Phik * ( (i(+1)) / i - 1 ) ;
# ir  =i / ( i(-1) ) ;
# irp =( i(+1) ) / i ;

# rb = Rb / pi ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% household sector
% (1)consumption; 
(c - habit * c(-1))^(-sigmac) - beta * habit * (c(+1) - habit * c)^(-sigmac) = lambda ;

% (2)labor; 
lambda * w = epsilonD * l ^ (Phi) ;

% (3)deposit;
lambda = beta * R * (lambda(+1)/pi(+1)) ;

% Financial Sector
% (4)entrepreneur's efficiency condition associated with the contract
(1-Fp1) / (1-GAMMAp1) = (rrp)*(1-Fp1-mu*ksibar(+1)*dFp1) 
       / (1-(rrp)*(GAMMAp1-mu*Gp1)) ;

% (5)Zero bank profit condition, i.e. the definition of leverage ratio
(GAMMAp1-mu*Gp1)*(rrp)*(x) = ((x)-1) ;

% (6)Ͷʵʱʵ
Rk / pi = (z + (1-delta)*q)/q(-1) ;

% (7)Ͷծȯʵ
Rb / pi = (1 - rho*qc)/qc(-1) ;

% (8)ͶͶʵʱص
Rk(+1) - Rb(+1) = wkbar * (wk - wks) ;

% (9)
portf = q * k + qc * B ;
% (10)
x = portf / n ;
% (11)
wk = (q * k)/portf ;
% (12)
Rp = Rk * wk(-1) + Rb * (1 - wk(-1)) + wkbar/2 * (wk(-1) - wks) ^ 2 ;
% (13)
rrp = Rp(+1)/R ;
% (14)
d = portf - n ;
% (15)
Rl = ksibar(+1) * Rp(+1) * portf / d ;

% (16)ͶͶʵʲֵ۷
n = gamma * v + We;

% (17)ͶͶʵ
v = Rp * portf(-1)/pi * (1-mu*G) - R(-1) * d(-1)/pi;

% ʱƷ
%(18)ʵʱۻ
k = (1-delta)*k(-1) + (1-Phi_x)*i;

% (19)investment decision
q = (1 - Phi_x - dPhi_x * ir + beta*(lambda(+1)/lambda)*(q(+1)/q) * dPhip_x * irp^2)^(-1);

% (20)capital-labor ratio
w / z=(1-alpha) / alpha * k / l;

% (21)wage decision
w = mc*A*(1-alpha)*(k/l)^alpha;

% (22) production technology
y = A * k^alpha * l^(1-alpha) / dp;

% (23) the price dispersion
dp = (pi^epsilon)*((1-theta)*pistar^(-epsilon)+theta*dp(-1));

% (24) auxiliary variable x1
x1 = lambda * mc * y + beta*theta*x1(+1)*(pi(+1))^epsilon;

% (25) auxiliary variable x2
x2 = lambda * y + beta*theta*x2(+1)*(pi(+1))^(epsilon-1) ;

% (26) optimal price decision
pistar = epsilon/(epsilon-1)*(pi)*(x1/x2);

% (27) the CPI evolution
pi^(1-epsilon) = theta + (1-theta)*(pistar^(1-epsilon));

%ԴԼ
% (28)ԴԼ
y = c + g + i + portf(-1)/pi * wkbar/2 * (wk(-1) - wks) ^ 2 ;

%Ҳ
% (29)Լ
qc * B + tau = rb * qc(-1) * B(-1) + g - Rp * portf(-1)/pi * mu*G ;

% (30)Government: Taylor rule; 
R = Rs * ( R(-1)/Rs )^phiR * ( pi/pis )^( phipi*(1-phiR) ) 
          * ( y/ys )^( phiy*(1-phiR) ) * exp(emt) ; 
% (30) This second Taylor rule is for the extended model
% exp(Rt) = Rs*(exp(Rt(-1))/Rs)^phiR*(exp(inflt)/infls)^(phips*(1-phiR))
%                  *(exp(yt)/ys)^(phiy*(1-phiR))*(exp(sigkt)/exp(sigks))^(0.005*(1-phiR))*exp(emt) ; 

% (31)
g = (1-rhog)*gs  + rhog*g(-1)  + gamgy*(log(y(-1))-log(ys)) 
          + gamgb*(B(-1)/(y(-1))-Bs/ys) + exp(sigg)*egt ;

% (32)
tau = (1-rhotau)*taus + rhotau*tau(-1) + gamtauy*(log(y(-1))-log(ys)) 
             + gamtaub*(B(-1)/(y(-1))-Bs/ys) + exp(sigtau)*etaut ;

% structural shocks
%(33)
log(A) = rhoa*log(A(-1)) + eat;

% (34)
log(sigma / sigma_ss) = rhosigma * log(sigma(-1) / sigma_ss)  + esigmat ;

% Volatility shocks
% (35)
sigg = (1-rhosigg)*siggs + rhosigg*sigg(-1) + (1-rhosigg^2)^(1/2) * etag * ugt ;

% (36)
sigtau = (1-rhosigtau)*sigtaus + rhosigtau*sigtau(-1) + (1-rhosigtau^2)^(1/2) * etatau * utaut ;
end ;


shocks ;
var emt = sigms^2;
var egt = 1 ; 
var etaut = 1 ;
var esigmat = 1 ;
var ugt = 1 ;
var utaut = 1 ;
end;

steady ;
resid(1) ;
check;
model_diagnostics;

stoch_simul(periods=1000,order=1,irf=20) k, i, c, R, ksibar, l ;

