function [ys,check]=maincodea_steadystate(ys,exe)

% compute s.s. This is the steady state file for the mod file;
% this file will automatically invoked by dynare and then s.s. 
% are returned.

global M_ options_
check = 0;

%the following statements ensure that the variables are not interpreted by
%MATLAB as functions... they will be reassigned values
%you do not need worry about values here.
habit = 0.75 ;  % From ACEL JFV(2015)
sigmac = 0.5 ;   % CRRA JFV(2015)
% beta = 0.99 ;  % Anna(2020)
beta = 1/1.0215 ;
% omegac = 0.99 ;  % ԴԴʽ2019
% phic = 0.5 ;  % ԴԴʽ2019
epsilonD = 4.2869;  % дҲ
Phi = 1 ;  % ԴԴʽ2019
mu = 0.2148945 ;  % Anna(2020)
delta = 0.02 ;  % Anna(2020)/0.01 JFV(2015)/0.025 Plessis et al(2014)
rho = 0.974 ;  % Anna(2020)
wkbar = 1.27 ;  % Anna(2020)
gamma = 0.9624 ;  % Anna(2020)
We = 0.013 ;  % Լ⣬дҲ
alpha = 0.36 ;  % Anna(2020)/ͬJFV(2015)
epsilon = 11 ;  % Anna(2020)/21 JFV(2015)
theta = 0.75 ;  % Լ⣬(۸ճ)дҲ
Phik = 2 ;  % Լ⣬дҲ
phiR =  0.7 ;  % JFV(2015)/0.95 Anna(2020)/0.8 IMF_WP(2017)
phipi = 1.35 ;  % JFV(2015)/1.476 Kevin Kotze(2017)/1.4 Anna(2020)
phiy = 0.25 ;  % JFV(2015)/0.3 IMF_WP(2017)/0.476 Kevin Kotze(2017)
rhog = 0.99 ;  % JFV(2015)/0.957 Kevin Kotze(2017)/0.98  Anna(2020)/Լɼйݽй
gamgy = -0.004 ;  % JFV(2015)/-0.004 Kevin Kotze(2017)/Լɼйݽй
gamgb = -0.008 ;  % JFV(2015)/-0.003 Kevin Kotze(2017)/Լɼйݽй
rhotau = 0.987 ;  %˰ʣｫJFV(2015)ƽԼɼйݽй/0.82  Kevin Kotze(2017)
gamtauy = 0.028 ;  %˰ʣｫJFV(2015)ƽԼɼйݽй/0.0093  Kevin Kotze(2017)
gamtaub = 0.002 ;  %˰ʣｫJFV(2015)ƽԼɼйݽй/-0.001  Kevin Kotze(2017)
rhoa = 0.98 ;  % IMF_WP(2017)
rhosigma = 0.86 ;   % IMF_WP(2017)
rhosigg = 0.92 ;  % JFV(2015)/0.938 Kevin Kotze(2017)/Լɼйݽй
rhosigtau = 0.62 ;  % ˰(0.46 - 0.73)JFV(2015)/0.661 - 0.994  Kevin Kotze(2017)/Լɼйݽй
etag = 0.18 ;    % JFV(2015)// std of inno to vola 
etatau = 0.40 ;   % JFV(2015) οʱ // std of inno to vola 
sigms = exp(-5.5) ;   % JFV(2015) steady-state vola

% Here we load the values of the deep parameters in a loop
% from dynare pre-processing info M_.
Np = M_.param_nbr;                                            
for I = 1:Np
    paramname = deblank(M_.param_names(I,:));
    eval([ paramname ' = M_.params(' int2str(I) ');']);
end

A = 1 ;
pi = 1 ;   %У׼Ϊ1 ;
pistar = 1 ;   %(27)
% R = 1 / beta ;   %(3)Rs;
R = 1.0215 ;
% rrp =(1.02)^(1/4);
rrp = 1.0073 ;
Rp = rrp * R ;
Fs = 0.0056 ;  
[sigma,ksibar,GAMMA,Gam_muG,ixx] = get_omega_cond_Fomegabar(rrp,Fs,mu);
Z = ( log(ksibar) + sigma^2 / 2 ) / sigma ;   %#Zs;
G = normcdf ( Z - sigma ) ;   %#Gs;
GAMMA = ksibar * (1-Fs) + G ;   %#GAMMAs;
dF = normpdf(Z) / ksibar / sigma ; 
 x = 1/(1- Gam_muG*rrp ) ; 
 
Rb = Rp ;   %(7)(8)(12)Rks.Rbs.qcs.
Rk = Rb ;   %(7)(8)(12)Rks.Rbs.qcs.
rb = Rb / pi ;
qc= (rb + rho)^(-1) ;   %(7)(8)(12)Rks.Rbs.qcs.

mc = (epsilon-1) / epsilon ;   %(24)(25)(26)mcs.
q = 1 ;   %(19)qs.
% Rks / pis = (zs + (1-delta)*qs) / qs ;   %(6)zs.
z = q * (Rk / pi - (1-delta)) ;
w = z * (1 - alpha) / alpha * (alpha*mc / z)^(1/(1-alpha)) ;      %ws;
dp = 1 ;   %

k_l = (w/z) * (alpha/(1-alpha)) ;
%  y = A * k^alpha * l^(1-alpha) / dp;
y_l = A * k_l^alpha / dp ;
l_y = 1 / y_l ;
% (13)  y_k = z / (mc * alpha) ;
y_k = z / (mc * alpha) ;
k_y = 1 / y_k ;
i_y = delta * k_y ;
g_y= 0.194 ;   %У׼ Anna(2020)
c_y = 1 - i_y - g_y ;   % Դ
l_c = l_y / c_y ;
% lambdaʾΪcĺlambda * w = epsilonD * l ^ (Phi)
% (1)ʽ(c - habit * c(-1))^(-sigmac) - beta * habit * (c(+1) - habit * c)^(-sigmac) = lambda ̬(2)ʽ
% (1)ʽ: lambda = (1 - beta * habit) * (1 - habit)^(-sigmac) * c^(-sigmac);
l = ( (1 - beta * habit) * (1 - habit)^(-sigmac) * l_c^sigmac * w / epsilonD ) ^ (1/(Phi+sigmac)) ;
k = k_l * l ;
y = y_l * l ;
% k = k_y * y ;
c = c_y * y ;
g = g_y * y ;
i = i_y * y ;

lambda = (1 - beta * habit) * (1 - habit)^(-sigmac) * c^(-sigmac);

portf = We / ( (1/x) - (gamma * (1 - GAMMA) * Rp) ) ;
n = portf/x ;
v = (1 - GAMMA) * Rp * portf ;
d = (Rp * portf/pi * (1-mu*G) - v) * pi / R ; 
Rl = ksibar * Rp * portf / d ;

wk = (q * k)/portf ;    %wks;
% portfs = qs * ks + qcs * Bs ;    %Bs;
B = (portf - q * k) / qc ;
% x1s = lambdas * mcs * ys + beta * theta * x1s * (pis)^epsilon ;    %x1s;
x1 = lambda * mc * y / ( 1 - beta * theta * (pi)^epsilon ) ;
% x2s = lambdas * ys + beta * theta * x2s * (pis)^(epsilon-1) ;    %x2s;
x2 = lambda * y / ( 1 - beta * theta * (pi)^(epsilon-1) );
% qcs * Bs + taus = rbs * qcs * Bs + gs - Rps * portfs/pis * mu*Gs ;    %taus;
tau = rb * qc * B + g - Rp * portf/pi * mu*G - qc * B ;

sigg = -6.20 ;   %ο2015
sigtau = -4.90 ;    %οʱ2015// steady-state vola

% Define the steady state values of the endogenous variables of the model.
%@2017-7-26 This steady state file will automatically invoked by Dynare, ys
%are returned to the Dynare.
Ne = M_.orig_endo_nbr;
ys = zeros(Ne,1);
% endoleadcount = 2;
% nonauxcount = 0;
for indexvar = 1:Ne
    varname = deblank(M_.endo_names(indexvar,:));
        eval(['ys(' int2str(indexvar) ') = ' varname ';']);
end



